#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    bool a[t];
    int n, m; bool s;
    for(int j = 0; j < t; j++){
        s = true;
        cin >> n >> m;
        long long b[n], c[m];
        for(int i = 0; i < n; i++)
            cin >> b[i];
        sort(b, b+n);
        long long dif = b[1]-b[0];
        for(int i = 2; i<n; i++)
            dif = min(dif, b[i]-b[i-1]);
        for(int i = 1; i < n; i++)
            if((b[i]-b[0])%dif != 0){
                s=false;
                break;
            }
        for(int i = 0; i < m; i++){
            cin >> c[i];
            if((c[i]-b[0])%dif==0)
                s=false;
        }
        a[j]=s;
    }
    for(int i = 0; i < t; i++)
        cout << a[i] << "\n";
}